﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Monnit;
using Monnit.Mine;

namespace SampleMineApplication
{
    public partial class MineSensor : Form
    {
        private Sensor _Sensor;

        public MineSensor(Sensor sensor)
        {
            InitializeComponent();

            _Sensor = sensor;
        }

        private void MineSensor_Load(object sender, EventArgs e)
        {
            if(_Sensor == null)
            {
                MessageBox.Show("Sensor is null");
                this.Close();
            }
            txtSensorID.Text = _Sensor.SensorID.ToString();
            txtSensorType.Text = (_Sensor.MonnitApplication).ToString();
            txtSensorFirmware.Text = _Sensor.FirmwareVersion.ToString();

           // cbSendGeneral1.Checked = _Sensor.GeneralConfigDirty;
            txtReportInterval.Text = _Sensor.ReportInterval.ToString();
            //Convert LinkInterval to minutes
            int link = _Sensor.TransmitIntervalLink;
            if (link > 100)
                link = link - 100;
            else
                link = link * 60;
            //txtLinkInterval.Text = link.ToString();
            txtReportInterval.Enabled = !_Sensor.GeneralConfigDirty;
            //txtLinkInterval.Enabled = !_Sensor.GeneralConfigDirty;
            btnUpdateConfig1.Enabled = !_Sensor.GeneralConfigDirty;
            
            //cbSendGeneral2.Checked = _Sensor.GeneralConfig2Dirty;
            //txtRetryCount.Text = _Sensor.RetryCount.ToString();
            //txtRecovery.Text = _Sensor.Recovery.ToString();
            //txtRetryCount.Enabled = !_Sensor.GeneralConfig2Dirty;
            //txtRecovery.Enabled = !_Sensor.GeneralConfig2Dirty;
            //btnUpdateConfig2.Enabled = !_Sensor.GeneralConfig2Dirty;

        }

        private void btnUpdateConfig1_Click(object sender, EventArgs e)
        {
            double ReportInterval = 0;
            //int TransmitIntervalLink = 0;
            
            try
            {
                if (!double.TryParse(txtReportInterval.Text, out ReportInterval))
                    throw new Exception("Invalid Report Interval");
                //if (!Int32.TryParse(txtLinkInterval.Text, out TransmitIntervalLink))
                //    throw new Exception("Invalid Interval Link");

                long MonnitAppID = Convert.ToInt64(_Sensor.MonnitApplication);

                //_ApplicationBase.GetType(MonnitAppID).CallStaticMethod("UpdateSensorGeneralConfig1", new object[] { _Sensor, ReportInterval, ReportInterval, TransmitIntervalLink, true });
                _ApplicationBase.GetType(MonnitAppID).CallStaticMethod("UpdateSensorHeartBeat", new object[] { _Sensor, ReportInterval, true });
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }

            MineSensor_Load(this, null);
        }

        //private void btnUpdateConfig2_Click(object sender, EventArgs e)
        //{
           
        //    int Recovery = 0;
            
        //    try
        //    {
              
        //        if (!Int32.TryParse(txtRecovery.Text, out Recovery))
        //            throw new Exception("Invalid Recovery");

        //        long MonnitAppID = Convert.ToInt64(_Sensor.MonnitApplication);
        //        _ApplicationBase.GetType(MonnitAppID).CallStaticMethod("UpdateSensorGeneralConfig2", new object[] { _Sensor, Recovery, true });

        //    }
        //    catch (Exception ex)
        //    {
        //        MessageBox.Show(ex.Message);
        //        return;
        //    }

           
        //    MineSensor_Load(this, null);
        //}
    }
}